#-*-ruby-*-
#
# Sixamo bot
#
# add config like this:
#
# BotConfig = {
#   :SixamoBot => {
#     :dir => 'dokoka',
#     :ch  => /nadoka/,
#     :tm  => 5
#   }
# }
#

require 'sixamo'
require 'kconv'
class SixamoBot < Nadoka::NDK_Bot
  def bot_initialize
    @sixamo_dir = config[:dir] || '~/sixamo'
    @sixamo_ch  = config[:ch]  || '#nadoka'
    @sixamo_tm  = config[:tm]  || 5
    @prev = Time.now
    make_sixamo
  end

  def make_sixamo
    @sixamo = Sixamo.new(File.expand_path(@sixamo_dir))
  end
  
  def on_privmsg user, ch, msg
    return unless @sixamo_ch === ch
    
    begin
      msg = Kconv.toeuc(msg)
      @sixamo.memorize msg

      return if Kernel.rand(2) == 1
      return if Time.now - @prev < @sixamo_tm
      @prev = Time.now

      talk = Kconv.tojis(@sixamo.talk(msg))
      send_notice ch, 'sixamo: ' + talk
    rescue
      make_sixamo
    end

  end
end

